import { PropType } from 'vue-demi';
import { Ref } from 'vue-demi';

export declare const Promised: import("vue-demi").DefineComponent<{
    promise: PropType<Promise<unknown> | null | undefined>;
    pendingDelay: {
        type: (NumberConstructor | StringConstructor)[];
        default: number;
    };
}, () => "" | import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
    [key: string]: any;
}>[] | null, unknown, {}, {}, import("vue-demi").ComponentOptionsMixin, import("vue-demi").ComponentOptionsMixin, Record<string, any>, string, import("vue-demi").VNodeProps & import("vue-demi").AllowedComponentProps & import("vue-demi").ComponentCustomProps, Readonly<{
    pendingDelay: string | number;
} & {
    promise?: Promise<unknown> | null | undefined;
}>, {
    pendingDelay: string | number;
}>;

declare type Refable<T> = Ref<T> | T;

/**
 * Returns the state of a Promise and observes the Promise if it's a Ref to
 * automatically update the state
 *
 * @param promise Ref of a Promise or raw Promise
 * @param pendingDelay optional delay to wait before displaying pending
 */
export declare function usePromise<T = unknown>(promise: Refable<Promise<T> | null | undefined>, pendingDelay?: Refable<number | string>): {
    isPending: import("vue-demi").Ref<boolean>;
    isDelayElapsed: import("vue-demi").Ref<boolean>;
    error: import("vue-demi").Ref<Error | null | undefined>;
    data: import("vue-demi").Ref<T | null | undefined>;
};

export { }
